#include"Shader.h"

#include"dmap.h"

class RenderBuffer
{
	private:
		GLuint rb;
		GLuint format;
		glm::ivec2 size;
		GLuint attachment_type;
	public:
		/*
		 * format: a renderable format like GL_RGBA8, GL_RGBA32, GL_R32
         * size : w,h
		 *attach_type: GL_COLOR_ATTACHMENTi, GL_DEPTH_ATTACHMENT, GL_STENCIL_ATTACHMENT or GL_DEPTH_STENCIL_ATTACHMMENT;
		 */
		RenderBuffer(const GLuint& _format, const glm::ivec2& _size, const GLuint& attach_type)
			:rb(0),format(_format), size(_size), attachment_type(attach_type)
		{
		}
		void ini()
		{
			glGenRenderbuffers(1,&rb);
			glBindRenderbuffer(GL_RENDERBUFFER, rb);
			glRenderbufferStorage(GL_RENDERBUFFER, format, size.x, size.y);
			
		}
		void resize(int width, int height)
		{
			glBindRenderbuffer(GL_RENDERBUFFER, rb);
			glRenderbufferStorage(GL_RENDERBUFFER, format, width, height);

		}
		/**
		 * mode can be GL_DRAW_FRAMEBUFFER GL_READ_FRAMEBUFFER
		 * */
		void attach(const GLuint& mode)
		{
			glFramebufferRenderbuffer(mode, attachment_type, GL_RENDERBUFFER, rb);
		}

		~RenderBuffer()
		{
			glDeleteRenderbuffers(1,&rb);
		}

		Depth_map get_depth_float()
		{
			Depth_map dmap;
			glBindRenderbuffer(GL_RENDERBUFFER, rb);
			unsigned char* data = new unsigned char[int(size.x*size.y)*sizeof(float)];
			glReadPixels(0,0,size.x,size.y,GL_DEPTH_COMPONENT,GL_FLOAT,data);
			dmap.set_depth_map(reinterpret_cast<float*>(data),size.x,size.y);
			//std::cout << *(reinterpret_cast<float*>(data)+1031574)<<std::endl;
			delete[] data;
			return dmap;
		}
		void save(const char* name)
		{
			glBindRenderbuffer(GL_RENDERBUFFER, rb);
			unsigned char* data = new unsigned char[int(size.x*size.y)*sizeof(float)];
			unsigned char* datac = new unsigned char[int(size.x*size.y)];
		//	unsigned char* datacy = new unsigned char[int(size.x*(size.y-1))];
			float* dataf = reinterpret_cast<float*>(data);
			float* dataf_ini = reinterpret_cast<float*>(data);
			//float* datafy = new float[int((size.x)*(size.y-1))];
			//float* datafy_ini = datafy;
			//float* dataf2 = dataf;
			unsigned char* datac_ini = datac;
			//unsigned char* datacy_ini = datacy;
			//unsigned char* data = new unsigned char[int(size.x*size.y)];
			glReadPixels(0,0,size.x,size.y,GL_DEPTH_COMPONENT,GL_FLOAT,data);
			//glReadPixels(0,0,size.x,size.y,GL_DEPTH_COMPONENT,GL_UNSIGNED_BYTE,data);
			float max(-10);
			float min(10);
			for(int i=0,i_end(size.x*size.y); i!=i_end;++i)
			{
				if(*dataf>max&&*dataf!=1.0f)
					max=*dataf;
				if(*dataf<min&&*dataf!=0.0f)
					min=*dataf;
				++dataf;
			}
			std::cout << min << " " << max << std::endl;
			std::cout << (min*2-1) << " " << (max*2-1) << std::endl;
			if(min==max)
			{
				delete[] data;
				delete[] datac;
				//delete[] datacy_ini;
				//delete[] datafy_ini;
				return;
			}
			float ratio = 255.0f/(max-min);
			dataf=dataf_ini;
			for(int i=0,i_end(size.x*size.y); i!=i_end;++i)
			{
				//*dataf = (*dataf-min)*ratio;
				//if(*dataf<0)
				//	*dataf=0;
				//if(*dataf>255)
				//	*dataf=255;
				//*datac = unsigned char(floor(*dataf));
				*datac = (unsigned char)(floor((*dataf-min)*ratio));
				++dataf;
				++datac;
			}
			Texture::save_data_mono(name,datac_ini,size.x,size.y);
			//std::cout << min << " " << max<< std::endl;
			//std::cout << size.x << " " << size.y<< std::endl;
			//std::getc(stdin);
			//
			//dataf=dataf_ini;
			//dataf2 = dataf;
			//dataf2+=int(size.x);
			//for(int j=0,j_end(size.y-1); j!=j_end;++j)
			//{
			//	for(int i=0,i_end(size.x); i!=i_end;++i)
			//	{
			//	//	if(*dataf==0||*dataf2==0||*dataf==255||*dataf2==255)
			//	//		*datafy=0;
			//	//	else
			//		*datafy = (*dataf2-*dataf)/2.0f;
			//		++datafy;
			//		++dataf;
			//		++dataf2;
			//	}
			//}
			//datafy=datafy_ini;
			//max=min=*datafy;
			//for(int i=0,i_end(size.x*(size.y-1)); i!=i_end;++i)
			//{
			//	if(*datafy>max)
			//		max=*datafy;
			//	if(*datafy<min)
			//		min=*datafy;
			//	++datafy;
			//}
			//if(min==max)
			//{
			//	delete[] data;
			//	delete[] datac;
			//	delete[] datacy_ini;
			//	delete[] datafy_ini;
			//	return;
			//}
			// ratio = 255.0/(max-min);
			//datafy=datafy_ini;
			//for(int i=0,i_end(size.x*(size.y-1)); i!=i_end;++i)
			//{
			//	*datacy = unsigned char(floor((*datafy-min)*ratio));
			//	//*datacy = unsigned char(floor((fabs(*datafy)*255)));//-min)*ratio));
			//	++datafy;
			//	++datacy;
			//}
			//Texture::save_data_mono(std::string(name)+"y.png",datacy_ini,size.x,size.y-1);
			//Texture::save_data_mono(name,data,size.x,size.y);
			
				delete[] data;
				delete[] datac_ini;
				//delete[] datacy_ini;
			//	delete[] datafy_ini;
			//std::cout << min << " " << max<< std::endl;
			//std::cout << size.x << " " << size.y<< std::endl;
			//std::getc(stdin);

	//		glBindTexture(GL_TEXTURE_2D, mTextureId);
	//		glGetTexLevelParameteriv(GL_TEXTURE_2D, 0, GL_TEXTURE_WIDTH, &w);
	//		glGetTexLevelParameteriv(GL_TEXTURE_2D, 0, GL_TEXTURE_HEIGHT, &h);
	//		//unsigned char* data = new unsigned char[w*h*4];
	//		//glGetTexImage(GL_TEXTURE_2D,0,GL_RGBA,GL_UNSIGNED_BYTE,data);
	//		unsigned char* data = new unsigned char[w*h*4];
	//		glGetTexImage(GL_TEXTURE_2D,0,GL_BGRA,GL_UNSIGNED_BYTE,data);
	//		bool tmp = save_texture(name,data,w,h);
	//		delete[] data;
	//		return tmp;
		}
};
class FBO
{
	private:
		GLuint fbo;
		std::vector<GLuint> attachment;
		std::map<std::string,std::shared_ptr<Texture_fbo>> texture;
		std::map<std::string,std::shared_ptr<RenderBuffer>> render_buffer;
		GLuint mode;
	public:
		FBO() :fbo(0), texture(), render_buffer()
		{
			
		}
		void ini()
		{
//			texture.clear();
//			render_buffer.clear();
			glGenFramebuffers(1,&fbo);
		}
		~FBO()
		{
			texture.clear();
			render_buffer.clear();
			glDeleteFramebuffers(1,&fbo);
		}
		void resize(int width, int height)
		{
			for (auto& a : texture)
			{
				a.second->resize(width, height);
			}
			for (auto& a : render_buffer)
			{
				a.second->resize(width, height);
			}
		}
		/**
		 * attachment have to be fill
		 * rec_src = [x0,y0,x1,y1] : the source window coordinates;
		 * rec_dst = [x0,y0,x1,y1] : the destination window coordinates;
		 * mask : a bitwise OR combination of the buffers to be copied. The available flags are: GL_COLOR_BUFFER, GL_DEPTH_BUFFER, and GL_STENCIL_BUFFER;
		 * filter: When the source area is different from the destination the image will be streched. As in regular textures two filters are available: GL_NEAREST and GL_LINEAR.
		 * Note that GL_LINEAR can only be used for color attachments.
		 * */
		void copy_to(const FBO& dst, const glm::ivec4& rec_src, const glm::ivec4& rec_dst, const int& mask=GL_COLOR_BUFFER_BIT, const int filter=GL_LINEAR)
		{
			enable_to_read(attachment[0]);
			//glBindFramebuffer(GL_READ_FRAMEBUFFER,fbo);
			//glReadBuffer(attachment[0]);
			glBindFramebuffer(GL_DRAW_FRAMEBUFFER,dst.fbo);
			glDrawBuffers((GLsizei)dst.attachment.size(),&*dst.attachment.begin());

			glBlitFramebuffer(rec_src.x,rec_src.y,rec_src.z,rec_src.w,
			                  rec_dst.x,rec_dst.y,rec_dst.z,rec_dst.w,
							  mask,filter);

		}
		void copy_to_screen(const glm::ivec4& rec_src, const glm::ivec4& rec_dst, const int& mask=GL_COLOR_BUFFER_BIT, const int filter=GL_LINEAR)
		{
			enable_to_read(attachment[0]);
			glBlitFramebuffer(rec_src.x,rec_src.y,rec_src.z,rec_src.w,
			                  rec_dst.x,rec_dst.y,rec_dst.z,rec_dst.w,
							  mask,filter);

		}
		void clear_attachment()
		{
			attachment.clear();
		}
		void add_attachment(){}
		void add_attachment(const GLuint& att)
		{
			attachment.push_back(att);
		}
		void add_attachment(const GLuint& att, const GLuint& a1 )
		{
			attachment.push_back(att);
			add_attachment(a1);
		}
		void add_attachment(const GLuint& att, const GLuint& a1 , const GLuint& a2 )
		{
			attachment.push_back(att);
			add_attachment(a1,a2);
		}
		void add_attachment(const GLuint& att, const GLuint& a1 , const GLuint& a2 , const GLuint& a3 )
		{
			attachment.push_back(att);
			add_attachment(a1,a2,a3);
		}
		void add_attachment(const GLuint& att, const GLuint& a1 , const GLuint& a2 , const GLuint& a3 , const GLuint& a4 )
		{
			attachment.push_back(att);
			add_attachment(a1,a2,a3,a4);
		}
		void enable_to_read(const GLuint& buf)
		{
			glBindFramebuffer(GL_READ_FRAMEBUFFER, fbo);
			glReadBuffer(buf);
			mode=GL_READ_FRAMEBUFFER;
		}
		void enable_to_render()
		{
			glBindFramebuffer(GL_DRAW_FRAMEBUFFER, fbo);
			glDrawBuffers((GLsizei)attachment.size(), &*attachment.begin());
			mode = GL_DRAW_FRAMEBUFFER;
		}
		void disable()
		{
			glBindFramebuffer(GL_DRAW_FRAMEBUFFER, 0);
			glBindFramebuffer(GL_READ_FRAMEBUFFER, 0);
		}
		/**
		 * if color = cube_map then depth have to be a cibe_map too;
		 * */
		void add_texture(std::string name, std::shared_ptr<Texture> _texture, const GLuint& attachment_type)
		{
			texture[name]=std::shared_ptr<Texture_fbo>(new Texture_fbo(_texture,attachment_type));
		}
		void add_texture(std::string name, std::shared_ptr<RenderBuffer> _render_buffer)
		{
			render_buffer[name]=_render_buffer;

		}
		void bind_for_draw()
		{
			glBindFramebuffer(GL_DRAW_FRAMEBUFFER, fbo);
			mode=GL_DRAW_FRAMEBUFFER;
		}
		void bind_for_read()
		{
			glBindFramebuffer(GL_READ_FRAMEBUFFER, fbo);
			mode=GL_READ_FRAMEBUFFER;
		}
		/**
		 *attachment_type = GL_COLOR_ATTACHMENT0 + i / GL_DEPTH_ATTACHMENT / ...
		 */
		void attach_texture(std::string name)
		{
			texture[name]->attach(mode);
		}
		void attach_render_buffer(std::string name)
		{
			render_buffer[name]->attach(mode);
		}
		void save_texture(const std::string& file_base_name, std::string name_target)
		{
			bind_for_read();
			attach_texture(name_target);
			texture[name_target]->save((file_base_name+name_target+".png").c_str());
			std::cout << "saved as " << (file_base_name+name_target+".png").c_str() << std::endl;
		}
		void save_renderbuffer(const std::string& file_base_name, std::string name_target)
		{
			bind_for_read();
			attach_render_buffer(name_target);
			render_buffer[name_target]->save((file_base_name+name_target+".png").c_str());
			std::cout << "saved as " << (file_base_name+name_target+".png").c_str() << std::endl;
		}
		Depth_map get_renderbuffer_depth_float(std::string name)
		{
			bind_for_read();
			attach_render_buffer(name);
			Depth_map tmp=render_buffer[name]->get_depth_float();
			return tmp;
		}
		/**
		 *This function tests attachments, and their coherency. For instance, if using multisampling, the number of samples must be the same for all texture attachments and render buffer attachments. Layered rendering also implies that all attachments must also be layered. For all the gritty details see the http://www.opengl.org/wiki/GLAPI/glCheckFramebufferStatus
		 *
		 */
		void check()
		{
			glBindFramebuffer(mode, fbo);
			GLenum e = glCheckFramebufferStatus(mode);
			if (e != GL_FRAMEBUFFER_COMPLETE)
				    std::cerr<<"There is a problem with the FBO"<<std::endl;
		}
};
