#pragma once
#ifndef __Texture__
#define __Texture__
#include"util_define.h"

class base_texture {
protected:
	GLuint mTextureId;
	std::string mName;
	GLuint mTextureType;
public:
	base_texture();
	base_texture(const glm::vec2& size);
	base_texture(const std::string& path);
	base_texture(const GLuint id);
	virtual ~base_texture();

	virtual bool loadTexture(const std::string& path){return false;}
	virtual bool save_texture(const std::string& name, unsigned char* data, const int& w, const int& h){return false;}
	bool download_texture(const std::string& name);
	void uploadTexture(const void* data, size_t size_x, size_t size_y, GLuint src_type);
	bool save_texture(const std::string& name)
	{
		return download_texture(name);
	}
	//texture have to be in 8 bit rgba
	bool loadTexture(const void* data, size_t size_x, size_t size_y, const std::string& name, GLuint src_type = GL_RGBA)
	{
		if(data)
		{
			mName = name;
			glGenTextures(1,&mTextureId);
			uploadTexture(data,size_x,size_y,src_type);
		}
		else
		{
			std::cerr << "Unable to load texture " << name << std::endl;
			return false;
		}
		return true;
	}
	void bind();
	GLuint getTextureId() const;

	std::string getName() {
		return mName;
	}
	GLuint getTextureType() const {
		return mTextureType;
	}
	void resize(int width, int height)
	{
		glBindTexture(GL_TEXTURE_2D, mTextureId);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);//GL_NEAREST
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, (GLsizei)width, (GLsizei)height, 0, GL_RGBA, GL_UNSIGNED_BYTE, nullptr);
	}
};

#endif

