#ifndef REPERE_ORIGIN_HEARER
#define REPERE_ORIGIN_HEARER

#include "util_define.h"
#include "Shader.h"
///!\ glm raisone en transposer : matrice[col][row] pour acceder et non [row][col]
struct repere_2d
{
	glm::vec2 t;
	float s;
	repere_2d() : s(1.0f), t(0.0f, 0.0f){}
	inline void set_repere_for_draw(Shader* shader, const glm::mat4& scene)const
	{
		shader->set_uniform("t", t);
		shader->set_uniform("s", s);
	}
};
class repere_origin
{
	public:
		repere_origin():m(){};
		inline void set_repere_for_draw(Shader* shader, const glm::mat4& scene)const
		{
			shader->set_uniform("repere", scene*get_repere());
		}
		const glm::mat4& get_repere()const
		{
			return m;
		}
		void set_repere(const glm::mat4& mm)
		{
			m=mm;
		}
		void reset_repere()
		{
			m=glm::mat4();
		}
		void translate(const glm::vec3& v)
		{
			m*=glm::translate(v);
		}
		void translate(const GLfloat& dx, const GLfloat& dy, const GLfloat& dz)
		{
			m*=glm::translate(glm::vec3(dx,dy,dz));
			// m*=glm::mat4{1,0,0,0,
			//			 0,1,0,0,
			//			 0,0,1,0,
			//			 dx,dy,dz,1};
		}
		void scale(const GLfloat& sx, const GLfloat& sy, const GLfloat& sz)
		{
			m*=glm::scale(glm::vec3(sx,sy,sz));
			//m=m*glm::mat4{sx,0,0,0,0,sy,0,0,0,0,sz,0,0,0,0,1};
		}
		void scale(const glm::vec3& v)
		{
			m*=glm::scale(v);
		}void rotate(const GLfloat& theta, const glm::vec3& v)
		{
			m*=glm::rotate(theta,v);
			//const GLfloat c = cos(theta);
			//const GLfloat s = sin(theta);
			//const GLfloat sx = x*s;
			//const GLfloat sy = y*s;
			//const GLfloat sz = z*s;
			//const GLfloat umc = 1-c;
			//const GLfloat umcxy = umc*x*y;
			//const GLfloat umcxz = umc*x*z;
			//const GLfloat umcyz = umc*y*z;
			//m*=glm::mat4{c+umc*x*x,umcxy+sz,umcxz-sy,0,
			//			 umcxy-sz,c+umc*y*y,umcyz+sx,0,
			//			 umcxz+sy,umcyz-sx,c+umc*z*z,0,
			//			 0,0,0,1};
		}
		void rotate_gauche(const GLfloat& theta, const glm::vec3& v)
		{
			m=glm::rotate(theta,v)*m;
			//const GLfloat c = cos(theta);
			//const GLfloat s = sin(theta);
			//const GLfloat sx = x*s;
			//const GLfloat sy = y*s;
			//const GLfloat sz = z*s;
			//const GLfloat umc = 1-c;
			//const GLfloat umcxy = umc*x*y;
			//const GLfloat umcxz = umc*x*z;
			//const GLfloat umcyz = umc*y*z;
			//m=glm::mat4{c+umc*x*x,umcxy+sz,umcxz-sy,0,
			//			 umcxy-sz,c+umc*y*y,umcyz+sx,0,
			//			 umcxz+sy,umcyz-sx,c+umc*z*z,0,
			//			 0,0,0,1}*m;
		}
		void rotate(const GLfloat& theta, const GLfloat& x, const GLfloat& y, const GLfloat& z)
		{
			m*=glm::rotate(theta,glm::vec3(x,y,z));
			//const GLfloat c = cos(theta);
			//const GLfloat s = sin(theta);
			//const GLfloat sx = x*s;
			//const GLfloat sy = y*s;
			//const GLfloat sz = z*s;
			//const GLfloat umc = 1-c;
			//const GLfloat umcxy = umc*x*y;
			//const GLfloat umcxz = umc*x*z;
			//const GLfloat umcyz = umc*y*z;
			//m*=glm::mat4{c+umc*x*x,umcxy+sz,umcxz-sy,0,
			//			 umcxy-sz,c+umc*y*y,umcyz+sx,0,
			//			 umcxz+sy,umcyz-sx,c+umc*z*z,0,
			//			 0,0,0,1};
		}
		void rotate_gauche(const GLfloat& theta, const GLfloat& x, const GLfloat& y, const GLfloat& z)
		{
			m=glm::rotate(theta,glm::vec3(x,y,z))*m;
			//const GLfloat c = cos(theta);
			//const GLfloat s = sin(theta);
			//const GLfloat sx = x*s;
			//const GLfloat sy = y*s;
			//const GLfloat sz = z*s;
			//const GLfloat umc = 1-c;
			//const GLfloat umcxy = umc*x*y;
			//const GLfloat umcxz = umc*x*z;
			//const GLfloat umcyz = umc*y*z;
			//m=glm::mat4{c+umc*x*x,umcxy+sz,umcxz-sy,0,
			//			 umcxy-sz,c+umc*y*y,umcyz+sx,0,
			//			 umcxz+sy,umcyz-sx,c+umc*z*z,0,
			//			 0,0,0,1}*m;
		}
	private:
		glm::mat4 m;
};

#endif


