#pragma once
#ifndef ___BINOMIAL____H___
#define ___BINOMIAL____H___

#include<array>
/*
usage : 

binomial_val<N, K> = "K parmi N" -> binomial coefficient


binomial<4>::data = std::array<int,5>{1 4 6 6 4 1}

binomial_array<N> contain a ptr to binomial<K>::data.data() for each K <= N

*/

template<unsigned int N, unsigned int K>
struct binomial_base;

template<unsigned int N, unsigned int K>
struct binomial_val : binomial_base<N,K>
{
};
template<unsigned int N, unsigned int K>
struct binomial_base
{
	static const int value = binomial_val<N - 1, K - 1>::value + binomial_val<N - 1, K>::value;
};
template<>
struct binomial_base<0, 0>
{
	static const int value = 1;
};
template<unsigned int N>
struct binomial_base<N, 0>
{
	static const int value = 1;
};
template<unsigned int N>
struct binomial_base<N, N>
{
	static const int value = 1;
};
//const int binomial_val<N, 0>::value = 1;
//const int binomial_val<0, 0>::value = 1;
//const int binomial_val<1, 0>::value = 1;
//const int binomial_val<1, 1>::value = 1;
//template<int N>
//const int binomial_val<N, 0>::value = 1;

//*
template<unsigned int... II> struct binomial_ini_list { typedef binomial_ini_list type; };
template<unsigned int N, unsigned int K, unsigned int... II> struct make_binomial;
template<unsigned int N, unsigned int... II> struct make_binomial<N, -1, II...> : binomial_ini_list<II...>{};
template<unsigned int N, unsigned int K, unsigned int... II> struct make_binomial : make_binomial<N, K - 1, binomial_val<N, K>::value, II...> {};


template<unsigned int N, typename indice>
struct coeff_bin;
template<unsigned int N, unsigned int... coeff>
struct coeff_bin<N, binomial_ini_list<coeff...>>
{
	static const std::array<int, N + 1> data;
};
template<unsigned int N, unsigned int... i>
const std::array<int, N + 1> coeff_bin<N, binomial_ini_list<i...>>::data = { i... };
template<unsigned int N>
struct make_coeff_bin :
	coeff_bin<N, typename make_binomial<N, N>::type> {};
template<int N>
struct binomial : make_coeff_bin<N>
{
};



template<typename... II> struct array_binomial_ini_list { typedef array_binomial_ini_list type; };
template<unsigned int N, typename... II> struct array_make_binomial;
template<typename... II> struct array_make_binomial<-1, II...> : array_binomial_ini_list<II...>{};
template<unsigned int N, typename... II> struct array_make_binomial : array_make_binomial<N - 1, binomial<N>, II...> {};

template<unsigned int N, typename truc>
struct binomial_array_constructor;
template<unsigned int N, typename... i>
struct binomial_array_constructor < N, array_binomial_ini_list<i...> >
{
	static const std::array<const int*, N+1> ptr_data;
};
template<unsigned int N, typename... i>
const std::array<const int*, N+1> binomial_array_constructor<N, array_binomial_ini_list<i...>>::ptr_data = { i::data.data()... };

template<unsigned int N>
struct array_make_coeff_bin :
	binomial_array_constructor<N, typename array_make_binomial<N>::type> {};
template<unsigned int K>
struct binomial_array : array_make_coeff_bin<K>
{
//	static const std::array<int*, K> ptr_data;
};
#endif