#ifndef SUPER_LINE_HEADER
#define SUPER_LINE_HEADER
#include "object.h"



class Line_obj : public base_object<Line_obj>
{
	public:
		Line_obj(VAO* ptr_vao, GLsizei _nb_line = 0) : base_object<Line_obj>(ptr_vao), nb_line(_nb_line), largeur_rec(0.001f){}
		virtual ~Line_obj(){}
		GLsizei nb_line;
		glm::vec2 size;
		float largeur_rec;
		void update_line(VBO& vbo_line, std::vector<glm::vec2>& line, std::vector<float>& line_color);
		void update_one_vertex(VBO& vbo_line, const std::size_t pos, const glm::vec2& val, float c, const glm::vec2& other_val);
		static void set_size(std::vector<glm::vec2>& line, std::vector<glm::vec3>& line_color, const float& largeur_rec, int& nb_line, bool pointille);
		static void ini_shader()
		{
			Shader s;
			s.loadVertexShaderFromFile("shader/shader_line.vert");
			s.loadFragmentShaderFromFile("shader/shader_line.frag");
			object::map_type_shader.emplace(std::make_pair(std::type_index(typeid(Line_obj)), std::move(s)));
		}
		inline void draw_2(const glm::mat4& scene)const
		{
			glDrawArrays(GL_TRIANGLES, 0, nb_line);
		}
};
class Point_obj : public base_object<Point_obj, repere_2d>
{
	public:
		//Point_obj();
		Point_obj(VAO* ptr_vao, const GLsizei& _nb_point = 0, const float& radius = 0.007, const float& _ratio = 16.0 / 9.0)
			: base_object<Point_obj, repere_2d>(ptr_vao), nb_point(_nb_point), radius_of_point(radius), ratio(_ratio){}
		virtual ~Point_obj(){}
		GLsizei nb_point;
		float radius_of_point;
		float ratio;
		static void ini_shader()
		{
			Shader s;
			s.loadVertexShaderFromFile("shader/shader_point.vert");
			s.loadGeometryShaderFromFile("shader/shader_point.geom");
			s.loadFragmentShaderFromFile("shader/shader_point.frag");
			object::map_type_shader.emplace(std::make_pair(std::type_index(typeid(Point_obj)), std::move(s)));
		}
		inline void draw_2(const glm::mat4& scene)const
		{
			shader->set_uniform("radius_of_point", radius_of_point);
			shader->set_uniform("ratio", ratio);
			glDrawArrays(GL_POINTS, 0, nb_point);
		}
};

class Line_obj_2 : public base_object<Line_obj_2, repere_2d>
{
	public:
		//Line_obj_2();
		Line_obj_2(VAO* ptr_vao, const GLsizei& _nb_line = 0, const float& _line_width = 1.0f)
			: base_object<Line_obj_2, repere_2d>(ptr_vao), nb_line(_nb_line), line_width(_line_width)
		{}

		virtual ~Line_obj_2(){}
		GLsizei nb_line;
		float line_width;
		static void ini_shader()
		{
			Shader s;
			s.loadVertexShaderFromFile("shader/shader_line.vert");
			s.loadFragmentShaderFromFile("shader/shader_line.frag");
			object::map_type_shader.insert(std::make_pair(std::type_index(typeid(Line_obj_2)), std::move(s)));
		}
	inline void draw_2(const glm::mat4& scene)const
	{
		glLineWidth(line_width);
		glDrawArrays(GL_LINES, 0, nb_line);
		glLineWidth(1.0);
	}
};
class Line_obj_const_color : public base_object<Line_obj_const_color, repere_2d>
{
public:
	//Line_obj_const_color();
	Line_obj_const_color(VAO* ptr_vao, const GLsizei& _nb_line = 0, const glm::vec3& _color = { 0, 0, 0 }, const float& _line_width = 1.0f)
		: base_object<Line_obj_const_color, repere_2d>(ptr_vao), nb_line(_nb_line), color(_color), line_width(_line_width)
	{}

	virtual ~Line_obj_const_color(){}
	GLsizei nb_line;
	glm::vec3 color;
	float line_width;
	static void ini_shader()
	{
		Shader s;
		s.loadVertexShaderFromFile("shader/shader_line_mono_color.vert");
		s.loadFragmentShaderFromFile("shader/shader_line_mono_color.frag");
		object::map_type_shader.insert(std::make_pair(std::type_index(typeid(Line_obj_const_color)), std::move(s)));
	}
	inline void draw_2(const glm::mat4& scene)const
	{
		shader->set_uniform("color", color);
		glLineWidth(line_width);
		glDrawArrays(GL_LINES, 0, nb_line);
		glLineWidth(1.0);
	}
};

//class Gen_obj : public object
//{
//public:
//	std::function<void(const glm::mat4& scene, const Gen_obj& obj)> fn;
//	void* special_data;
//
//protected:
//	virtual void draw_2(const glm::mat4& scene)const
//	{
//		shader->enable();
//		fn(scene, *this);
//		Shader::disable();
//	}
//};

#endif


