#pragma once
#ifndef ___GL_CROSS_OBJ__
#define ___GL_CROSS_OBJ__

#include "object.h"

class gl_cross_obj : public base_object<gl_cross_obj, repere_2d>
{
	public:
		gl_cross_obj(VAO* ptr_vao, const GLsizei& _nb_point = 0, const float& _line_semi_length = 0.05, const float& _line_semi_thickness = 0.0025, const float& _ratio = 16.0 / 9.0)
			: base_object<gl_cross_obj, repere_2d>(ptr_vao), nb_point(_nb_point), line_semi_length(_line_semi_length),line_semi_thickness(_line_semi_thickness), ratio(_ratio){}
		virtual ~gl_cross_obj(){}
		GLsizei nb_point;
		float line_semi_length;
		float line_semi_thickness;
		float ratio;
		static void ini_shader()
		{
			Shader s;
			s.loadVertexShaderFromFile("shader/shader_point.vert");
			s.loadGeometryShaderFromFile("shader/shader_point_cross.geom");
			s.loadFragmentShaderFromFile("shader/shader_point.frag");
			object::map_type_shader.emplace(std::make_pair(std::type_index(typeid(gl_cross_obj)), std::move(s)));
		}
		inline void draw_2(const glm::mat4& scene)const
		{
			shader->set_uniform("line_semi_length", line_semi_length);
			shader->set_uniform("line_semi_thickness", line_semi_thickness);
			shader->set_uniform("ratio", ratio);
			glDrawArrays(GL_POINTS, 0, nb_point);
		}
};
#endif

