#ifndef SUPER_IMAGE_TEX_HEADER
#define SUPER_IMAGE_TEX_HEADER
#include "object.h"



class Image_tex : public base_object<Image_tex, repere_2d>
{
public:
		//Image_tex();
		Image_tex(VAO* ptr_vao, const char* texture_file_name = "", float _depth = 0.0f)
			:base_object<Image_tex, repere_2d>(ptr_vao), tex_name(texture_file_name), depth(_depth)
		{
			if (texture_file_name != "")
				set_texture("texture", std::shared_ptr<Texture>(new Texture(texture_file_name)));
		}
		Image_tex(VAO* ptr_vao, const cv::Mat_<float>& img, std::string texture_name = "", float _depth = 0.0f)
			:base_object<Image_tex, repere_2d>(ptr_vao), tex_name(texture_name), depth(_depth)
		{
			set_texture("texture", std::shared_ptr<Texture>(new Texture(img)));
		}
		Image_tex(VAO* ptr_vao, const cv::Mat_<cv::Vec3f>& img, std::string texture_name = "", float _depth = 0.0f)
			:base_object<Image_tex, repere_2d>(ptr_vao), tex_name(texture_name), depth(_depth)
		{
			set_texture("texture", std::shared_ptr<Texture>(new Texture(img)));
		}
		virtual ~Image_tex(){}
		void set_texture(const std::string& name, GLuint i);
		void set_texture(const std::string& name, const std::shared_ptr<Texture>& i);
		static std::function<void (std::string& name, std::vector<glm::vec2>&)> ini_default_tex_data;
		static std::function<void(std::string& name, std::vector<glm::vec3>&)> ini_default_vertex_data;
		static void ini_shader()
		{
			Shader s;
			s.loadVertexShaderFromFile("shader/shader_tex.vert");
			s.loadFragmentShaderFromFile("shader/shader_tex.frag");
			object::map_type_shader.emplace(std::make_pair(std::type_index(typeid(Image_tex)), std::move(s)));
		}
		inline void draw_2(const glm::mat4& scene)const
		{
		//	std::cout << "draw" << std::endl;
			shader->setTexture(tex_name, texture);
			shader->bindTextures();
			shader->set_uniform("alpha", alpha);
			shader->set_uniform("depth", depth);
			glDrawArrays(GL_QUADS, 0, 4);
		}
	public:
		std::string tex_name;
		std::shared_ptr<Texture> texture;
		float alpha;
		float depth;
};

#endif


