#pragma once
#ifndef ___OBJ_BEZIER___HEADER___
#define ___OBJ_BEZIER___HEADER___
#include "object.h"


class obj_bezier : public base_object<obj_bezier, repere_2d>
{
public:
	//obj_bezier();
	obj_bezier(VAO* ptr_vao, const GLsizei& _nb_line = 0, const glm::vec3& color = { 0, 0, 0 }, const float& _line_width = 1)
		: base_object<obj_bezier, repere_2d>(ptr_vao), nb_line(_nb_line), line_width(_line_width), color_curve(color)
	{}
	virtual ~obj_bezier(){}
	GLsizei nb_line;
	float line_width;
	glm::vec3 color_curve;
	static void ini_shader()
	{
		Shader s;
		s.loadVertexShaderFromFile("shader/shader_bezier.vert");
		s.loadFragmentShaderFromFile("shader/shader_bezier.frag");
		object::map_type_shader.emplace(std::make_pair(std::type_index(typeid(obj_bezier)), std::move(s)));
	}
	inline void draw_2(const glm::mat4& scene)const
	{
		shader->set_uniform("color_curve", color_curve);
		glLineWidth(line_width);
		glDrawArrays(GL_LINES, 0, nb_line);
		glLineWidth(1.0);
	}
};


#endif