#pragma once
#ifndef __SAVE_FILE____HEADER__
#define __SAVE_FILE____HEADER__

template<typename T> inline void write(std::ostream& os, const T& n)
{
	os.write(reinterpret_cast<const char*>(&n), sizeof(decltype(n)));
}
template<typename T, typename U> inline void write(std::ostream& os, const T& n, const U& nb_elem)
{
	os.write(reinterpret_cast<const char*>(&n), sizeof(decltype(n))*nb_elem);
}
template<typename T> inline void read(std::istream& is, T& n)
{
	is.read(reinterpret_cast<char*>(&n), sizeof(decltype(n)));
}
template<typename T, typename U> inline void read(std::istream& is, T& n, const U& nb_elem)
{
	is.read(reinterpret_cast<char*>(&n), sizeof(decltype(n))*nb_elem);
}
inline void write_string(std::ostream& os, const std::string& data)
{
	write(os, data.size());
	if (data.size())
		write(os, data[0], data.size());
}
inline void read_string(std::istream& is, std::string& data)
{
	decltype(data.size()) n;
	read(is, n);
	data.resize(n);
	if (n)
		read(is, data[0], n);
}
inline void write_mat(std::ostream& os, const cv::Mat_<int>& data)
{
	write(os, data.rows);
	write(os, data.cols);
	if (data.rows && data.cols)
		write(os, *data.ptr(), data.rows*data.cols*sizeof(int));
}
inline void read_mat(std::istream& is, cv::Mat_<int>& data)
{
	decltype(data.rows) rows;
	read(is, rows);
	decltype(data.cols) cols;
	read(is, cols);
	data = cv::Mat_<int>(rows, cols);
	if (data.rows && data.cols)
		read(is, *data.ptr(), data.rows*data.cols*sizeof(int));
}
#endif //__SAVE_FILE____HEADER__

