#pragma once
#ifndef ____MAIN_HEADER_____
#define ____MAIN_HEADER_____
#include <cstdio>
#include <cstdlib>
#include <ctime>

#include<chrono>
#include"util_define.h"

#include"data_structure.h"

#include"simulated_annealing.h"

#include <CGAL/Exact_predicates_inexact_constructions_kernel.h>
#include <CGAL/squared_distance_2.h>
#include <CGAL/Triangulation_vertex_base_with_info_2.h>
#include <CGAL/Triangulation_face_base_with_info_2.h>
#include <CGAL/Delaunay_triangulation_2.h>

#include"main_windows.h"

typedef CGAL::Exact_predicates_inexact_constructions_kernel Kernel;
//typedef CGAL::Simple_cartesian<double> Kernel;

struct Mon_info
{
	int info;
	Mon_info() : info(-1) {}
	Mon_info(const int& i) : info(i) {}
	Mon_info(const Mon_info& m) : info(m.info) {}
	Mon_info(Mon_info&& m) : info(m.info) {}
	operator int&() { return info; }
	operator const int&()const { return info; }
	Mon_info& operator=(Mon_info&& m) { info = m.info; return *this; }
	Mon_info& operator=(const Mon_info& m) { info = m.info; return *this;}
};

typedef CGAL::Triangulation_vertex_base_with_info_2<Mon_info, Kernel> VerticesInfo;
typedef CGAL::Triangulation_face_base_with_info_2<Mon_info, Kernel> FacesInfo;
typedef CGAL::Triangulation_data_structure_2<VerticesInfo, FacesInfo> Tds;


template<template< class> typename CostVertex, template< class> typename CostEdge, template< class> typename CostFace, typename DataCost, typename Label = int>
struct delaunay_point_process : public simulated_annealing<Ma_Triangulation_2<CGAL::Delaunay_triangulation_2, Tds, Kernel,
	Label, CostVertex, CostEdge, CostFace, DataCost>>
{
	typedef typename simulated_annealing<Ma_Triangulation_2<CGAL::Delaunay_triangulation_2, Tds, Kernel,
		Label, CostVertex, CostEdge, CostFace, DataCost>> SA;
	delaunay_point_process(DPP::Parameters& parameters, const std::string base_name, const std::string full_name) :simulated_annealing<Ma_Triangulation_2<CGAL::Delaunay_triangulation_2, Tds, Kernel,
		Label,CostVertex, CostEdge, CostFace, DataCost>>(parameters) {
		srand(std::chrono::system_clock::now().time_since_epoch().count());

		DataCost::ini_from_file(base_name, full_name);
		cv::imwrite("input_image.png", DataCost::img_color*255.0f);
		cv::imwrite("input_grad_norm.png", DataCost::img_grad*255.0f);
		parameters.point_distribution = &DataCost::img_grad;
		this->reset(parameters);// SA::Triangulation::Ini_data_cost::img);
		all_step();
		//save stuff
		DataCost::save_output(*this, DataCost::img_color.rows, DataCost::img_color.cols);
	}
};
template<template< class> typename CostVertex, template< class> typename CostEdge, template< class> typename CostFace, typename DataCost, typename GuiRendering, typename Label = int>
struct delaunay_point_process_gui : public simulated_annealing<Ma_Triangulation_2<CGAL::Delaunay_triangulation_2, Tds, Kernel,
	Label, CostVertex, CostEdge, CostFace, DataCost, GuiRendering>>
{
	typedef typename simulated_annealing<Ma_Triangulation_2<CGAL::Delaunay_triangulation_2, Tds, Kernel,
		Label, CostVertex, CostEdge, CostFace, DataCost, GuiRendering>> SA;
	MainWindows<SA> mainWin;
	delaunay_point_process_gui() :SA(DPP::Parameters()) {
		srand(std::chrono::system_clock::now().time_since_epoch().count());
	}
};


#endif