#include"gl_widget.h"

void gl_widget::wheelEvent(QWheelEvent *event)
{
	int numDegrees = event->delta() / 8;
	int numSteps = numDegrees / 15;

	if (event->orientation() == Qt::Vertical)
	{
		if (s > 1 || (s == 1 && numSteps>0))
		{
			s+=numSteps;
			if (s <= 0)
				s = 1;
		}
		else
		{
			s_den -= numSteps;
			if (s_den <= 0)
				s_den = 1;
			s = 1.0f / s_den;
		}
		set_t_s();
		update();
	}
	event->accept();
}
void gl_widget::mousePressEvent(QMouseEvent* event)
{
	m_last_pos = event->pos();
	m_last_pos_vec2_in_sketch_coord = coordinate_window_to_gl({ m_last_pos.x(), m_last_pos.y() });
}
void gl_widget::mouseMoveEvent(QMouseEvent* event)
{
	float dx = float((event->pos().x() - m_last_pos.x())) * scale_size.x / width()  * 2;
	float dy = float((event->pos().y() - m_last_pos.y())) *scale_size.y / height() * 2;
	m_last_pos = event->pos();
	glm::mat4 tmp;
	tmp = this->get_repere();

	switch (event->buttons())
	{
	case Qt::LeftButton:
		if (event->modifiers() == Qt::ControlModifier)
		{
			glm::vec2 tmp = coordinate_window_to_gl_viewport(glm::vec2(m_last_pos.x(), m_last_pos.y()));
			if (tmp.x < 0)
				tmp.x = 0;
			if (tmp.y < 0)
				tmp.y = 0;
			if (tmp.x > 1)
				tmp.x = 1;
			if (tmp.y > 1)
				tmp.y = 1;
		pixel_label_1.emplace((int)(tmp.x*img_cols), (int)(tmp.y*img_rows));
		}
		else if (event->modifiers() == Qt::AltModifier)
		{
			glm::vec2 tmp = coordinate_window_to_gl_viewport(glm::vec2(m_last_pos.x(), m_last_pos.y()));
			if (tmp.x < 0)
				tmp.x = 0;
			if (tmp.y < 0)
				tmp.y = 0;
			if (tmp.x > 1)
				tmp.x = 1;
			if (tmp.y > 1)
				tmp.y = 1;
			pixel_label_2.emplace((int)(tmp.x*img_cols), (int)(tmp.y*img_rows));
		}
		else
		{
			t.x += dx / s;
			t.y -= dy / s;
			set_t_s();
			update();
		}
		break;
	}
}
void gl_widget::keyReleaseEvent(QKeyEvent * event)
{
		switch(event->key())
		{			
		case Qt::Key_Y:
			fbo.save_texture("","color");
			fbo.save_renderbuffer("","depth");
			break;
		case Qt::Key_T:
			update();
			fbo.save_texture("","color");
			fbo.save_renderbuffer("","depth");
			break;
		case Qt::Key_Left:
			t.x += 5.0f / m_width / s;
			set_t_s();
			update();
			break;
		case Qt::Key_Right:
			t.x -= 5.0f / m_width / s;
			set_t_s();
			update();
			break;
		case Qt::Key_Up:
			t.y -= 5.0f / m_height / s;
			set_t_s();
			update();
			break;
		case Qt::Key_Down:
			t.y += 5.0f / m_height / s;
			set_t_s();
			update();
			break;
		case Qt::Key_Plus:
			s++;
			set_t_s();
			update();
			break;
		case Qt::Key_Minus:
			s--;
			set_t_s();
			update();
			break;
		default:
			break;
		
	}
}