#include"main.h"


#include"cost_image_compression.h"
#include"cost_line_network_extraction.h"
#include"cost_object_contouring.h"
#include"gui_image_compression.h"
#include"gui_line_network_extraction.h"
#include"gui_object_contouring.h"

int demo_line_network_extraction(int argc, char** argv);
int demo_image_compression(int argc, char** argv);
int demo_object_contouring(int argc, char** argv);
int demo_gui_line_network_extraction(int argc, char** argv);
int demo_gui_image_compression(int argc, char** argv);
int demo_gui_object_contouring(int argc, char** argv);
int main(int argc, char** argv)
{
	return demo_gui_object_contouring(argc, argv);
}


int demo_line_network_extraction(int argc, char** argv)
{
	DPP::Parameters parameters;
	const std::string base_name = "$w2_bd_m_l";
	const std::string full_name = "C:\\data\\data_3\\$w2_bd_m_l.png";
	delaunay_point_process<
		Cost_vertices_line_network_extraction,
		Cost_edges_line_network_extraction,
		Cost_faces_line_network_extraction,
		ini_data_cost_line_network_extraction> mon_dpp(parameters, base_name, full_name);
	return EXIT_SUCCESS;
}
int demo_image_compression(int argc, char** argv)
{
	DPP::Parameters parameters;
	const std::string base_name = "bin_fleur";
	const std::string full_name = "C:\\data\\data_3\\bin_fleur.png";
	delaunay_point_process<
		Cost_vertices_ImageCompression,
		Cost_edges_ImageCompression,
		Cost_faces_ImageCompression,
		ini_data_cost_image_compression> mon_dpp(parameters, base_name, full_name);
	return EXIT_SUCCESS;
	
}
int demo_line_drawing_vectorization(int argc, char** argv)
{

	return EXIT_SUCCESS;
}
int demo_object_contouring(int argc, char** argv)
{
	DPP::Parameters parameters;
	const std::string base_name = "bin_fleur";
	const std::string full_name = "C:\\data\\data_3\\bin_fleur.png";
	delaunay_point_process<
		Cost_vertices_object_contouring,
		Cost_edges_object_contouring,
		Cost_faces_object_contouring,
		ini_data_cost_object_contouring> mon_dpp(parameters, base_name, full_name);
	return EXIT_SUCCESS;

}

int demo_gui_line_network_extraction(int argc, char** argv)
{
	QApplication app(argc, argv);
	if (!QGLFormat::hasOpenGL()) {
		QMessageBox::critical(NULL, "Attention", QObject::tr("desole pas d'OpenGL !"));
		return -1;
	}
	app.setApplicationName("Line network extraction by Delaunay Point Process");
	delaunay_point_process_gui<
		Cost_vertices_line_network_extraction,
		Cost_edges_line_network_extraction,
		Cost_faces_line_network_extraction,
		ini_data_cost_line_network_extraction,
		gui_rendering_line_network_extraction> mon_dpp;
	mon_dpp.mainWin.resize(1024, 1024);
	mon_dpp.mainWin.show();
	//mainWin.setVisible(true);
	return app.exec();
}
int demo_gui_image_compression(int argc, char** argv)
{
	QApplication app(argc, argv);
	if (!QGLFormat::hasOpenGL()) {
		QMessageBox::critical(NULL, "Attention", QObject::tr("desole pas d'OpenGL !"));
		return -1;
	}
	app.setApplicationName("Image vectorization by Delaunay Point Process");
	delaunay_point_process_gui<
		Cost_vertices_ImageCompression,
		Cost_edges_ImageCompression,
		Cost_faces_ImageCompression,
		ini_data_cost_image_compression,
		gui_rendering_image_compression> mon_dpp;
	mon_dpp.mainWin.resize(1024, 1024);
	mon_dpp.mainWin.show();
	//mainWin.setVisible(true);
	return app.exec();
}
int demo_gui_object_contouring(int argc, char** argv)
{
	QApplication app(argc, argv);
	if (!QGLFormat::hasOpenGL()) {
		QMessageBox::critical(NULL, "Attention", QObject::tr("desole pas d'OpenGL !"));
		return -1;
	}
	app.setApplicationName("Object contouring by Delaunay Point Process");
	delaunay_point_process_gui<
		Cost_vertices_object_contouring,
		Cost_edges_object_contouring,
		Cost_faces_object_contouring,
		ini_data_cost_object_contouring,
		gui_rendering_object_contouring> mon_dpp;
	mon_dpp.mainWin.resize(1024, 1024);
	mon_dpp.mainWin.show();
	//mainWin.setVisible(true);
	return app.exec();
}
